<?php

$config = array(
	in 		=> "viewtopic.php",
	out 	=> "viewtopic_buzer.php",
	backup	=> "viewtopic_buzer_org.php",
	buzer	=> "buzer_phpbb2.php",
	errors	=> array(),
	msgs	=> array(),
	content => "",
	incl 	=> "",
	set	 	=> "",
	charset	=> "",
);




if ( isset($_GET['install']) and preg_match("/^1$/", $_GET['install'])) {
	# Installation
	
	if ( isset($_GET['charset']) and preg_match("/^([a-z0-9\-]+)$/", $_GET['charset'], $treffer) ) {
		$config[charset] = $treffer[1];
	} else {
		$config[charset] = "iso-8859-1";
	}
	array_push($config[msgs], "verwende '$config[charset]'");
	
	$install = "Installation " . (install($config) ? "" : "nicht ") . "erfolgreich<br />";

}

if ( isset($_GET['deinstall']) and preg_match("/^1$/", $_GET['deinstall'])) {
	# Deinstallation
	
	
	$deinstall = "Deinstallation " . (deinstall($config) ? "" : "nicht ") . "erfolgreich<br />";

}

if ( count($config[errors])) {
	$error 	= '<b>aufgetretene Fehler:</b><div style="color:red;">' . implode( '<br />', $config[errors]) . '</div>';
}

if ( count($config[msgs])) {
	$msg 	= '<b>Ablauf:</b><div style="color:green;">' . implode( '<br />', $config[msgs]) . '</div>';
}

$content = <<<HTML
<html>
	<head>
		<title>Buzer-Plugin (de)installieren</title>
	</head>
	<body style="padding:10px;">
		<div style=""> Mit diesem Skript knnen Sie das Plugin installieren und wieder entfernen</div>
		<div style="margin-top:20px;padding:5px;border:1px solid #000000;"><b>Installation</b><br /><br />
			Vor der Installation mssen Sie die im Zip-File enthaltene Datei '$config[buzer]' in das Stammverzeichnis Ihrer phpBB-Installation kopiert haben.<br /><br />
			<form action="">
				vom Forum verwendetes Charset <input type="text" name="charset" value="$config[charset]"> (2.x wahrscheinlich 'iso-8859-1', 3.x wahrscheinlich 'utf-8')<br />
				<input type="submit" value="jetzt installieren">
				<input type="hidden" name="install" value="1">
			</form>
		</div>
		<div style="margin-top:20px;padding:5px;border:1px solid #000000;"><b>Deinstallation</b><br /><br />
			Es wird die bei der Installation als '$config[backup]' gesicherte '$config[in]' wiederhergestellt<br /><br />
			<form action="">
				<input type="submit" value="jetzt deinstallieren">
				<input type="hidden" name="deinstall" value="1">
			</form>
			
		</div>
		<div style="margin-top:20px;padding:5px;border:1px solid #000000;"><b>Ergebnis:</b><br />
			$install
			$deinstall<br />
			$msg<br /><br />
			$error<br /><br />
		</div>
	</body>
</html>
HTML;

echo $content;

function deinstall(&$config) {

	
	if (!is_writeable( "./")) { 
		array_push($config[errors], "Verzeichnis './' nicht schreibbar");
		return 0;
	}

	if ( !is_file( $config[backup])) {
		array_push($config[errors], "Datei '$config[backup]' nicht gefunden");
		return 0;
	}
	
	if ( !is_writeable( $config[backup])) {
		array_push($config[errors], "Datei '$config[backup]' nicht schreibbar");
		return 0;
	}
	
	if ( !is_writeable( $config[in])) {
		array_push($config[errors], "Datei '$config[in]' nicht schreibbar");
		return 0;
	}
	
	if ( is_file($config[out]) ) {
		if (!is_writeable( $config[out])) {
			array_push($config[errors], "Datei '$config[out]' nicht schreibbar");
			return 0;
		} else {
			if ( !unlink($config[out]) ) {
				array_push($config[errors], "Datei '$config[out]' nicht lschbar");
				return 0;
			}
		}
	} 
	
	# Tabelle erzeugen
	define('IN_PHPBB', true);
	$phpbb_root_path = './';
	include($phpbb_root_path . 'extension.inc');
	include($phpbb_root_path . 'common.'.$phpEx);

	# anlegen cache
	if ( !$db->sql_query( 'drop table buzer_cache', false)) {
		array_push($config[errors], "Cache-Tabelle 'buzer_cache' konnte nicht entfernt werden");
		return 0;
	} else {
		array_push($config[msgs], "Cache-Tabelle 'buzer_cache' entfernt");
	}

	$rename = rename( $config[in], $config[out] );
	if ( $rename ) {
		array_push($config[msgs], "Datei '$config[in]' verschoben nach '$config[out]'");
	} else {
		array_push($config[errors], "Datei '$config[in]' konnte nicht nach '$config[out]' verschoben werden");
		return 0;
	}
	
	$rename = rename( $config[backup], $config[in] );
	if ( $rename ) {
		array_push($config[msgs], "Datei '$config[backup]' wiederhergestellt als '$config[in]'");
	} else {
		array_push($config[errors], "Datei '$config[backup]' konnte nicht als '$config[in]' wiederhergestellt werden");
	}
	
	return $rename;
}


function install(&$config) {

	if ( !is_writeable( $config[in])) {
		array_push($config[errors], "Datei '$config[in]' nicht schreibbar");
		return 0;
	}
	if ( !is_writeable( "./")) {
		array_push($config[errors], "im Verzeichnis kann './' nicht geschrieben werden");
		return 0;
	}
	if ( is_file($config[out]) and !is_writeable( $config[out])) {
		array_push($config[errors], "die Datei '$config[out]' nicht geschrieben werden");
		return 0;
	}
	if ( !is_file($config[buzer])) {
		array_push($config[errors], "die Datei '$config[buzer]' wurde nicht gefunden");
		return 0;
	}
	if ( !is_readable($config[buzer])) {
		array_push($config[errors], "die Datei '$config[buzer]' ist nicht lesbar");
		return 0;
	}
	
	# Tabelle erzeugen
	define('IN_PHPBB', true);
	$phpbb_root_path = './';
	include($phpbb_root_path . 'extension.inc');
	include($phpbb_root_path . 'common.'.$phpEx);
	
	# anlegen cache
	if ( !$db->sql_query( 'create table if not exists buzer_cache (id int primary key, hash varchar(32), cache mediumtext not null, dateinsert datetime, dateupdate datetime, state tinyint, unique index pk_buzer_cache_hash (hash))', false)) {
		array_push($config[errors], "cache Tabelle konnte nicht erzeugt werden");
		return 0;
	} else {
		array_push($config[msgs], "Cache-Tabelle 'buzer_cache' erzeugt");
	}
		
		
	# ermitteln der letzten Post-ID
	$db->sql_query("insert ignore into ".CONFIG_TABLE."(config_name, config_value) select 'buzer_max_postid', max(cast(post_id as signed)-100000) from ". POSTS_TABLE);
	$db->sql_query("insert ignore into ".CONFIG_TABLE." (config_name, config_value) values ('buzer_cache_table', 'buzer_cache')");
	
	
	
	$fin 		= fopen($config[in], 'r');
	$fout 		= fopen($config[out], 'w');
	$include	= '';
	$set		= '';

	while ( $line = fgets($fin )) {

		if ( !$include and preg_match( '/^(\s*include\s*\(\s*\$.*)(includes\/bbcode\.\'\s*\.\s*\$phpEx\s*\)\s*;)/',$line, $treffer )) {
			# eintragen des includes
			fwrite( $fout, $line);
			fwrite( $fout, "$treffer[1]$config[buzer]');\n");
			$include = "Datei '$config[out]': Einfgen der Zeile '$treffer[1]$config[buzer]');'";
			array_push($config[msgs], $include);
			
		} elseif ( $include and !$set and preg_match( '/^(\s*\'MESSAGE\'\s*\=\>\s*)\$message\s*,/',$line, $treffer )) {
			# eintragen aufruf der linkfunktion
			fwrite( $fout, "# $line");
			$set = "Datei '$config[out]': Auskommentieren der Zeile '$line'";
			array_push($config[msgs], $set);
			#fwrite( $fout, "$treffer[1]buzer_LinkIt(\$message, \$row['post_id'], '$config[charset]'),\n");
			$flineout = "$treffer[1] (\$board_config['buzer_max_postid'] and \$board_config['buzer_max_postid']<\$postrow[\$i]['post_id']) ? \$gBuzer->buzer_LinkIt(\$message, '$config[charset]', \$postrow[\$i]['post_id']) : \$message,";
			fwrite( $fout, "$flineout\n");			
			#$set = "Datei '$config[out]': Einfgen der Zeile '$treffer[1]buzer_LinkIt(\$message, \$row['post_id'], '$config[charset]'),'";
			$set = "Datei '$config[out]': Einfgen der Zeile '$flineout'";			
			array_push($config[msgs], $set);
			
		} else {
			fwrite( $fout, $line);
		}
		

	}
	fclose($fout);
	fclose($fin);
	
	if ( !$include ) {
		array_push($config[errors], "die Position zum Einfgen der 'include'-Zeile wurde nicht gefunden");
	}
	if ( !$set ) {
		array_push($config[errors], "die Position zum Einfgen der 'linkIt'-Zeile wurde nicht gefunden");
	}
	
	
	if ( $include and $set ) {
		# sichern der originaldatei und bernehmen der genderten
		$mv_backup = rename( $config[in], $config[backup]);
		if ( $mv_backup	) {
			array_push($config[msgs], "Datei '$config[in]' wurde in '$config[backup]' umbenannt (Backup)");
		} else {
			array_push( $config[errors], "Datei '$config[in]' konnte nicht in '$config[backup]' umbenannt werden (Backup)");
		}
		if ( $mv_backup ) {
			$mv_new = rename( $config[out], $config[in]);
			if ( $mv_new ) {
				array_push( $config[msgs], "Datei '$config[out]' wurde in '$config[in]' umbenannt (Hook)");
			} else {
				array_push( $config[errors], "Datei '$config[out]' konnte nicht in '$config[in]' umbenannt werden (Hook)");
			}
		}
		
		return ($mv_backup and $mv_new);
	}
}

?>